diff --git a/src/tui/bb-agent-tui.ts b/src/tui/bb-agent-tui.ts
new file mode 100644
index 0000000..118028f
--- /dev/null
+++ b/src/tui/bb-agent-tui.ts
@@ -0,0 +1,483 @@
+import fs from 'node:fs';
+import os from 'node:os';
+import path from 'node:path';
+import readline from 'node:readline';
+import { pathToFileURL, fileURLToPath } from 'node:url';
+import { resolveAgentWorkspace } from '../lib/agent-workspace';
+import { bootstrapManagedPi, ensureManagedPiSettings } from '../lib/bb-pi-bootstrap';
+import { detectPiRuntimeStrategy } from '../lib/pi-runtime-detection';
+import { createDoltReadTool } from './tools/bb-dolt-read';
+import { createMailboxTools } from './tools/bb-mailbox';
+import { createPresenceTools } from './tools/bb-presence';
+import { createDeviationTool } from './tools/bb-deviation';
+import { buildBeadBoardSystemPrompt } from './system-prompt';
+
+export interface BbAgentTuiOptions {
+  cwd?: string;
+  agentDir?: string;
+  projectKey?: string | null;
+  projectRoot?: string | null;
+  input?: NodeJS.ReadableStream;
+  output?: NodeJS.WritableStream;
+  initialMessage?: string;
+  testMode?: boolean;
+  debug?: boolean;
+}
+
+type BbManagedSession = {
+  prompt: (text: string) => Promise<void>;
+  dispose: () => void;
+  subscribe: (listener: (event: any) => void) => () => void;
+  model?: { id?: string; provider?: string } | null;
+  modelRegistry?: {
+    getAll?: () => Array<{ id: string; provider: string }>;
+    getAvailable?: () => Promise<Array<{ id: string; provider: string }>>;
+    find?: (provider: string, modelId: string) => { id: string; provider: string } | null;
+    authStorage?: {
+      login?: (provider: string, callbacks: {
+        onAuth: (payload: { url: string; instructions?: string }) => void;
+        onPrompt: (payload: { message: string }) => Promise<string | null>;
+        onProgress?: (message: string) => void;
+      }) => Promise<void>;
+    };
+  };
+  settingsManager?: {
+    setDefaultModelAndProvider?: (provider: string, modelId: string) => void;
+  };
+  setModel?: (model: { id: string; provider: string }) => Promise<void>;
+};
+
+function renderBanner(): string {
+  return [
+    '╔══════════════════════════════════════════════════════════════╗',
+    '║                  BeadBoard Pi Runtime TUI                  ║',
+    '╠══════════════════════════════════════════════════════════════╣',
+    '║ Talk directly to the BeadBoard agent runtime.           ║',
+    '║ Commands: /exit, /quit, /help                              ║',
+    '╚══════════════════════════════════════════════════════════════╝',
+  ].join('\n');
+}
+
+async function loadPiSdk(): Promise<Record<string, any> & { resolution: Awaited<ReturnType<typeof detectPiRuntimeStrategy>> }> {
+  const resolution = await detectPiRuntimeStrategy();
+
+  if (resolution.installState === 'bootstrap-required' || !resolution.sdkPath) {
+    return {
+      createAgentSession: async () => {
+        throw new Error(`Agent runtime required at ${resolution.managedRoot}`);
+      },
+      resolution,
+    };
+  }
+
+  const candidates = [resolution.sdkPath].filter((candidate): candidate is string => Boolean(candidate));
+
+  const errors: string[] = [];
+  for (const candidate of candidates) {
+    try {
+      const mod = await import(pathToFileURL(candidate).href);
+      if (typeof mod.createAgentSession === 'function') {
+        return { ...mod, resolution };
+      }
+    } catch (error) {
+      errors.push(error instanceof Error ? error.message : String(error));
+    }
+  }
+
+  throw new Error(`Unable to load Pi SDK createAgentSession() for ${resolution.mode} (${resolution.installState}). ${resolution.reason} ${errors.join(' | ')}`);
+}
+
+export function renderBbAgentTuiBanner(): string {
+  return renderBanner();
+}
+
+function getDefaultShellPath(): string | null {
+  if (process.platform === 'win32') {
+    return process.env.ComSpec ?? 'C:\\Windows\\System32\\cmd.exe';
+  }
+
+  const candidates = ['/bin/sh', '/usr/bin/sh', '/bin/bash', '/usr/bin/bash'];
+  for (const candidate of candidates) {
+    if (fs.existsSync(candidate)) {
+      return candidate;
+    }
+  }
+
+  return null;
+}
+
+function buildSafePath(existingPath: string | undefined, shellPath: string | null): string {
+  const entries = new Set<string>();
+  const delimiter = path.delimiter;
+
+  for (const entry of String(existingPath ?? '').split(delimiter)) {
+    if (entry.trim()) {
+      entries.add(entry.trim());
+    }
+  }
+
+  const home = process.env.HOME ?? os.homedir();
+  const preferredEntries = process.platform === 'win32'
+    ? [
+        path.dirname(shellPath ?? process.env.ComSpec ?? 'C:\\Windows\\System32\\cmd.exe'),
+      ]
+    : [
+        path.join(home, '.local', 'bin'),
+        shellPath ? path.dirname(shellPath) : '',
+        '/usr/local/bin',
+        '/usr/bin',
+        '/bin',
+        '/usr/sbin',
+        '/sbin',
+      ];
+
+  for (const entry of preferredEntries) {
+    if (entry) {
+      entries.add(entry);
+    }
+  }
+
+  return Array.from(entries).join(delimiter);
+}
+
+export function ensureSafeShellEnvironment(env: NodeJS.ProcessEnv = process.env): { path: string; shell: string | null } {
+  const shellPath = getDefaultShellPath();
+  const safePath = buildSafePath(env.PATH ?? env.Path, shellPath);
+
+  if (process.platform === 'win32') {
+    env.PATH = safePath;
+    env.Path = safePath;
+    if (shellPath && !env.ComSpec) {
+      env.ComSpec = shellPath;
+    }
+  } else {
+    env.PATH = safePath;
+    if (shellPath && !env.SHELL) {
+      env.SHELL = shellPath;
+    }
+  }
+
+  return { path: safePath, shell: shellPath };
+}
+
+function rewriteManagedPiError(message: string, agentDir: string): string {
+  return message.replace(/\/home\/clawdbot\/\.pi\/agent\/models\.json/g, path.join(agentDir, 'models.json'));
+}
+
+function formatModelChoices(session: BbManagedSession): string {
+  const available = session.modelRegistry?.getAll?.() ?? [];
+  if (available.length === 0) {
+    return 'No models are registered yet.';
+  }
+  return available.map((model) => `- ${model.provider}/${model.id}`).join('\n');
+}
+
+async function handleLoginCommand(session: BbManagedSession, text: string, output: NodeJS.WritableStream, rl: readline.Interface): Promise<void> {
+  const provider = text.split(/\s+/)[1];
+  const authStorage = session.modelRegistry?.authStorage;
+  const supportedProviders = ['anthropic', 'github-copilot', 'google-gemini-cli', 'google-antigravity'];
+
+  if (!provider) {
+    output.write(`Login requires a provider. Try one of:\n- ${supportedProviders.join('\n- ')}\n`);
+    return;
+  }
+
+  if (!supportedProviders.includes(provider)) {
+    output.write(`Unsupported login provider: ${provider}\nSupported: ${supportedProviders.join(', ')}\n`);
+    return;
+  }
+
+  if (!authStorage?.login) {
+    output.write('Managed Pi auth storage is unavailable.\n');
+    return;
+  }
+
+  await authStorage.login(provider, {
+    onAuth: ({ url, instructions }) => {
+      output.write(`Open this URL to continue login for ${provider}:\n${url}\n`);
+      if (instructions) {
+        output.write(`${instructions}\n`);
+      }
+    },
+    onPrompt: ({ message }) => new Promise((resolve) => {
+      rl.question(`${message} `, (answer) => resolve(answer ?? ''));
+    }),
+    onProgress: (message) => {
+      output.write(`${message}\n`);
+    },
+  });
+
+  const availableModels = await session.modelRegistry?.getAvailable?.() ?? [];
+  if (!session.model && availableModels.length > 0 && session.setModel) {
+    await session.setModel(availableModels[0]);
+    session.settingsManager?.setDefaultModelAndProvider?.(availableModels[0].provider, availableModels[0].id);
+    output.write(`Selected model: ${availableModels[0].provider}/${availableModels[0].id}\n`);
+  }
+}
+
+async function handleModelCommand(session: BbManagedSession, text: string, output: NodeJS.WritableStream): Promise<void> {
+  const requested = text.split(/\s+/)[1];
+  if (!requested) {
+    output.write(`Available models:\n${formatModelChoices(session)}\nUsage: /model <provider/model>\n`);
+    return;
+  }
+
+  const [provider, ...modelParts] = requested.split('/');
+  const modelId = modelParts.join('/');
+  if (!provider || !modelId) {
+    output.write('Usage: /model <provider/model>\n');
+    return;
+  }
+
+  const model = session.modelRegistry?.find?.(provider, modelId);
+  if (!model || !session.setModel) {
+    output.write(`Model not found: ${requested}\nAvailable models:\n${formatModelChoices(session)}\n`);
+    return;
+  }
+
+  await session.setModel(model);
+  session.settingsManager?.setDefaultModelAndProvider?.(model.provider, model.id);
+  output.write(`Selected model: ${model.provider}/${model.id}\n`);
+}
+
+export async function runBbAgentTui(options: BbAgentTuiOptions = {}): Promise<void> {
+  const input = options.input ?? process.stdin;
+  const output = options.output ?? process.stdout;
+  const debug = options.debug ?? process.env.BB_TUI_DEBUG === '1';
+  const logDebug = (message: string) => {
+    if (debug) {
+      output.write(`[bb tui debug] ${message}\n`);
+    }
+  };
+
+  output.write(`${renderBanner()}\n`);
+
+  const shellEnv = ensureSafeShellEnvironment();
+  logDebug(`shell env ready: shell=${shellEnv.shell ?? 'unknown'} path=${shellEnv.path}`);
+
+  if (options.testMode) {
+    output.write('[bb tui test mode]\n');
+    return;
+  }
+
+  const workspace = await resolveAgentWorkspace({
+    currentProjectRoot: options.cwd ?? process.cwd(),
+    requestedProjectKey: options.projectKey ?? null,
+    requestedProjectRoot: options.projectRoot ?? null,
+  });
+  logDebug(`workspace: ${workspace.root} (${workspace.source})`);
+
+  let resolution = await detectPiRuntimeStrategy();
+  if (resolution.installState === 'bootstrap-required') {
+    output.write(`[bb tui] Installing agent runtime at ${resolution.managedRoot}\n`);
+    await bootstrapManagedPi({ output });
+    resolution = await detectPiRuntimeStrategy();
+  }
+
+  const managedAgentDir = options.agentDir ?? resolution.agentDir;
+  await ensureManagedPiSettings(managedAgentDir);
+  process.env.PI_CODING_AGENT_DIR = managedAgentDir;
+  logDebug(`managed agent dir: ${managedAgentDir}`);
+
+  logDebug('loading Pi SDK');
+  const sdk = await loadPiSdk();
+  const {
+    createAgentSession,
+    createReadTool,
+    createBashTool,
+    createEditTool,
+    createWriteTool,
+    AuthStorage,
+    ModelRegistry,
+    SessionManager,
+    SettingsManager,
+    loadSkillsFromDir,
+  } = sdk;
+  logDebug(`pi runtime mode: ${resolution.mode} (${resolution.installState})`);
+  if (resolution.installState === 'bootstrap-required') {
+    output.write(`[bb tui error] Agent runtime required at ${resolution.managedRoot}\n`);
+    output.write('[bb tui error] Automatic bb-pi bootstrap failed.\n');
+    return;
+  }
+  logDebug('creating Pi session');
+
+  let session: any;
+  let managedSession: BbManagedSession;
+  let currentWorkspaceRoot = workspace.root;
+
+  const rootDir = path.resolve(path.dirname(fileURLToPath(import.meta.url)), '../..');
+  const driverSkills = loadSkillsFromDir ? loadSkillsFromDir({
+    dir: path.join(rootDir, 'skills'),
+    source: 'beadboard',
+  }).skills : [];
+
+  async function startSession(root: string) {
+    if (session) {
+      session.dispose();
+    }
+    currentWorkspaceRoot = root;
+    const authStorage = new AuthStorage(path.join(managedAgentDir, 'auth.json'));
+    const modelRegistry = new ModelRegistry(authStorage, path.join(managedAgentDir, 'models.json'));
+    const settingsManager = SettingsManager.create(root, managedAgentDir);
+    const sessionManager = SessionManager.create(root);
+    
+    // Evaluate the system prompt once before creating the session since the SDK does not await the function
+    const dynamicPrompt = await buildBeadBoardSystemPrompt(root, `You are a headless orchestrator for the BeadBoard system.`);
+
+    const res = await createAgentSession({
+      cwd: root,
+      agentDir: managedAgentDir,
+      authStorage,
+      modelRegistry,
+      settingsManager,
+      sessionManager,
+      systemPrompt: dynamicPrompt,
+      tools: [
+        createReadTool(root),
+        createBashTool(root),
+        createEditTool(root),
+        createWriteTool(root),
+      ],
+      hooks: [],
+      skills: driverSkills,
+      contextFiles: [],
+      slashCommands: [],
+      customTools: [
+        { tool: createDoltReadTool(root) },
+        { tool: createDeviationTool(root) },
+        ...createMailboxTools().map((tool) => ({ tool })),
+        ...createPresenceTools().map((tool) => ({ tool })),
+      ],
+    });
+    session = res.session;
+    managedSession = session as BbManagedSession;
+
+    session.subscribe((event: any) => {
+      if (event.type === 'message_start') {
+        logDebug(`message_start:${event.message.role}`);
+      }
+      if (event.type === 'tool_execution_start') {
+        logDebug(`tool_start:${event.toolName}`);
+        output.write(`\n> Running tool: ${event.toolName}...\n`);
+      }
+      if (event.type === 'tool_execution_end') {
+        logDebug(`tool_end:${event.toolName}:${event.isError ? 'error' : 'ok'}`);
+        if (event.isError) {
+          output.write(`> Tool error: ${event.toolName}\n`);
+        }
+      }
+      if (event.type === 'message_update') {
+        const ame = event.assistantMessageEvent;
+        if (ame.type === 'text_delta') {
+          output.write(ame.delta);
+        } else if (ame.type === 'thinking_delta') {
+          output.write(`\x1b[90m${ame.delta}\x1b[0m`); // dim text for thinking
+        } else if (ame.type === 'error') {
+          output.write(`\n\x1b[31m[Agent Error] ${ame.error.errorMessage}\x1b[0m\n`);
+        }
+      }
+      if (event.type === 'agent_end') {
+        logDebug('agent_end');
+        
+        // Safety check in case the error wasn't streamed via message_update
+        const lastMsg = event.messages?.[event.messages.length - 1];
+        if (lastMsg?.role === 'assistant' && lastMsg.stopReason === 'error' && lastMsg.errorMessage) {
+          output.write(`\n\x1b[31m[Agent Error] ${lastMsg.errorMessage}\x1b[0m\n`);
+        }
+        
+        output.write('\n\n');
+      }
+    });
+  }
+
+  await startSession(workspace.root);
+  logDebug(`session ready (model: ${session.model?.id ?? 'unknown'})`);
+
+  const rl = readline.createInterface({
+    input,
+    output,
+    prompt: 'bb> ',
+  });
+
+  const close = async () => {
+    rl.close();
+    session.dispose();
+  };
+
+  rl.on('line', async (line) => {
+    const text = line.trim();
+    if (!text) {
+      rl.prompt();
+      return;
+    }
+    if (text === '/exit' || text === '/quit') {
+      await close();
+      return;
+    }
+    if (text === '/help') {
+      output.write('Enter a prompt to talk to BeadBoard Pi. Use /exit to quit.\n');
+      output.write('Commands: /help, /exit, /quit, /login <provider>, /model <provider/model>, /workspace <path>\n');
+      rl.prompt();
+      return;
+    }
+
+    try {
+      if (text === '/workspace' || text.startsWith('/workspace ')) {
+        const newWorkspace = text.slice(10).trim();
+        if (!newWorkspace) {
+          output.write(`Current workspace: ${currentWorkspaceRoot}\nUsage: /workspace <path>\n`);
+        } else {
+          const resolvedPath = path.resolve(currentWorkspaceRoot, newWorkspace);
+          if (!fs.existsSync(resolvedPath)) {
+            output.write(`Workspace path does not exist: ${resolvedPath}\n`);
+          } else {
+            await startSession(resolvedPath);
+            output.write(`Workspace switched to: ${resolvedPath}\n`);
+          }
+        }
+        rl.prompt();
+        return;
+      }
+      if (text === '/login' || text.startsWith('/login ')) {
+        await handleLoginCommand(managedSession, text, output, rl);
+        rl.prompt();
+        return;
+      }
+      if (text === '/model' || text.startsWith('/model ')) {
+        await handleModelCommand(managedSession, text, output);
+        rl.prompt();
+        return;
+      }
+
+      logDebug(`prompt:start:${text}`);
+      await session.prompt(text);
+      logDebug('prompt:resolved');
+    } catch (error) {
+      const rawMessage = error instanceof Error ? error.message : String(error);
+      const message = rewriteManagedPiError(rawMessage, managedAgentDir);
+      output.write(`\n[bb tui error] ${message}\n`);
+      logDebug(`prompt:error:${message}`);
+    }
+
+    rl.prompt();
+  });
+
+  rl.on('close', () => {
+    session.dispose();
+  });
+
+  if (options.initialMessage) {
+    try {
+      logDebug(`initialPrompt:start:${options.initialMessage}`);
+      await session.prompt(options.initialMessage);
+      logDebug('initialPrompt:resolved');
+    } catch (error) {
+      const rawMessage = error instanceof Error ? error.message : String(error);
+      const message = rewriteManagedPiError(rawMessage, managedAgentDir);
+      output.write(`\n[bb tui error] ${message}\n`);
+      logDebug(`initialPrompt:error:${message}`);
+    }
+  }
+
+  rl.prompt();
+}
diff --git a/src/tui/bb-daemon-tui.ts b/src/tui/bb-daemon-tui.ts
new file mode 100644
index 0000000..400fc81
--- /dev/null
+++ b/src/tui/bb-daemon-tui.ts
@@ -0,0 +1,63 @@
+import { bbDaemon, type BbDaemonLifecycleStatus } from '../lib/bb-daemon';
+
+export interface BbDaemonTuiProjectSummary {
+  projectRoot: string;
+  orchestratorStatus: string;
+  eventCount: number;
+}
+
+export interface BbDaemonTuiSnapshot {
+  daemonStatus: BbDaemonLifecycleStatus | string;
+  projects: BbDaemonTuiProjectSummary[];
+}
+
+function shortenProjectRoot(projectRoot: string): string {
+  const parts = projectRoot.replaceAll('\\', '/').split('/').filter(Boolean);
+  return parts.slice(-2).join('/') || projectRoot;
+}
+
+export function renderDaemonTuiSnapshot(snapshot: BbDaemonTuiSnapshot): string[] {
+  const header = [
+    '╔══════════════════════════════════════════════════════════════╗',
+    '║                    BeadBoard Daemon TUI                    ║',
+    '╠══════════════════════════════════════════════════════════════╣',
+    `║ Daemon Status : ${String(snapshot.daemonStatus).padEnd(44)}║`,
+    `║ Projects      : ${String(snapshot.projects.length).padEnd(44)}║`,
+    '╠══════════════════════════════════════════════════════════════╣',
+  ];
+
+  const projectLines = snapshot.projects.length
+    ? snapshot.projects.flatMap((project) => {
+        const label = shortenProjectRoot(project.projectRoot);
+        return [
+          `║ Project       : ${label.padEnd(44)}║`,
+          `║ Orchestrator  : ${project.orchestratorStatus.padEnd(44)}║`,
+          `║ Runtime Events: ${String(project.eventCount).padEnd(44)}║`,
+          '╟──────────────────────────────────────────────────────────────╢',
+        ];
+      })
+    : ['║ No registered daemon projects yet.                          ║', '╟──────────────────────────────────────────────────────────────╢'];
+
+  const footer = [
+    '║ Commands: bb daemon start | bb daemon status | bb daemon tui║',
+    '╚══════════════════════════════════════════════════════════════╝',
+  ];
+
+  return [...header, ...projectLines, ...footer];
+}
+
+export function renderDaemonTuiFromRuntime(): string[] {
+  const status = bbDaemon.getStatus();
+  return renderDaemonTuiSnapshot({
+    daemonStatus: status.lifecycle.status,
+    projects: status.projects.map((project) => ({
+      projectRoot: project.projectRoot,
+      orchestratorStatus: project.orchestratorStatus,
+      eventCount: project.eventCount,
+    })),
+  });
+}
+
+export function renderDaemonTuiText(): string {
+  return renderDaemonTuiFromRuntime().join('\n');
+}
diff --git a/src/tui/system-prompt.ts b/src/tui/system-prompt.ts
new file mode 100644
index 0000000..d737c75
--- /dev/null
+++ b/src/tui/system-prompt.ts
@@ -0,0 +1,222 @@
+import { readIssuesFromDisk } from '../lib/read-issues';
+import { getAgentTypes, getTemplates } from '../lib/server/beads-fs';
+
+export async function buildBeadBoardSystemPrompt(workspaceRoot: string, defaultPrompt: string): Promise<string> {
+  let issuesContext = '';
+  try {
+    const allIssues = await readIssuesFromDisk({ projectRoot: workspaceRoot });
+    // Keep context somewhat tight by excluding closed/tombstoned issues for the initial state overview
+    const activeIssues = allIssues.filter((i) => !['closed', 'tombstone'].includes(i.status));
+    
+    const compactIssues = activeIssues.map(i => ({
+      id: i.id,
+      title: i.title,
+      status: i.status,
+      assignee: i.assignee || 'unassigned',
+    }));
+    
+    issuesContext = JSON.stringify(compactIssues, null, 2);
+  } catch (error) {
+    issuesContext = `Failed to read tasks (Dolt may not be running). Error: ${error instanceof Error ? error.message : String(error)}`;
+  }
+
+  let agentTypesContext = '';
+  try {
+    const agentTypes = await getAgentTypes(workspaceRoot);
+    const compactAgentTypes = agentTypes.map(a => ({
+      id: a.id,
+      name: a.name,
+      description: a.description,
+      capabilities: a.capabilities,
+    }));
+    agentTypesContext = JSON.stringify(compactAgentTypes, null, 2);
+  } catch (error) {
+    agentTypesContext = `Failed to read agent types: ${error instanceof Error ? error.message : String(error)}`;
+  }
+
+  let templatesContext = '';
+  try {
+    const templates = await getTemplates(workspaceRoot);
+    const compactTemplates = templates.map(t => ({
+      id: t.id,
+      name: t.name,
+      description: t.description,
+      team: t.team,
+    }));
+    templatesContext = JSON.stringify(compactTemplates, null, 2);
+  } catch (error) {
+    templatesContext = `Failed to read templates: ${error instanceof Error ? error.message : String(error)}`;
+  }
+
+  return `${defaultPrompt}
+
+---
+
+# Agent System
+
+You can spawn agent workers to accomplish tasks in parallel. Agents are typed workers with specific capabilities:
+
+- **architect**: System design, work decomposition, technical decisions (read-only, does not modify code)
+- **engineer**: Implementation, coding, testing, debugging (full code access)
+- **reviewer**: Code review, quality analysis (read-only, does not modify code)
+- **tester**: Test design and implementation (full code access)
+- **investigator**: Debugging, root cause analysis (read-only unless implementing a confirmed fix)
+- **shipper**: Deployment, CI/CD, release management (full code access)
+
+## Spawning Agents
+
+Use \`bb_spawn_worker\` to spawn an agent for a specific task. You can spawn multiple agents in parallel.
+
+## Agent Instances
+
+When you spawn an agent, it gets a numbered instance (e.g., "Engineer 01", "Engineer 02"). The right panel shows all active agent instances with their status.
+
+## Templates
+
+Templates are named compositions of agents:
+- **feature-dev**: architect + 2x engineer + reviewer + tester
+- **bug-fix**: investigator + engineer + tester
+- **greenfield**: architect + 3x engineer + tester + shipper
+
+Use templates for large efforts (epics). For small tasks, spawn individual agents directly.
+
+## Task Scope Decision Tree
+
+Before spawning agents, assess task scope:
+
+### Small Task (Single Agent)
+- Bug fix with known cause
+- Single file change
+- Quick refactor
+- Single test addition
+
+**Action:** Spawn 1 agent directly. Example: \`bb_spawn_worker\` with \`agentType: "engineer"\`
+
+### Medium Task (2-3 Agents)
+- Feature with clear design
+- Bug investigation + fix
+- Code review + fixes
+
+**Action:** Spawn 2-3 agents based on template or custom composition.
+
+### Large Task (Use Template)
+- New feature from scratch
+- System redesign
+- Multi-component changes
+
+**Action:** Use \`bb_spawn_template\` with appropriate template:
+- \`feature-dev\` for new features
+- \`bug-fix\` for debugging issues
+- \`greenfield\` for new projects
+- \`full-squad\` for complex multi-domain work
+
+### Epic Creation
+If the task requires multiple beads with dependencies:
+1. Use \`bb_create_epic\` to create the epic
+2. Use \`bb_create\` to create child beads
+3. Assign agent types to each bead with \`bb_assign_agent\`
+4. Spawn agents to work on unblocked beads
+
+**Example Flow:**
+\`\`\`
+User: "Build user authentication system"
+
+Orchestrator:
+1. "This is a large task. Creating epic 'User Authentication'."
+2. Creates epic + decomposes into beads:
+   - BEAD-001: Design auth schema [architect]
+   - BEAD-002: Implement JWT service [engineer]
+   - BEAD-003: Implement refresh tokens [engineer]
+   - BEAD-004: Write auth tests [tester]
+   - BEAD-005: Review implementation [reviewer]
+3. Spawns Architect 01 to start on BEAD-001
+4. When BEAD-001 done, spawns Engineer 01 and 02 for BEAD-002 and BEAD-003
+5. And so on...
+\`\`\`
+
+---
+
+## Worker Coordination Workflow
+
+When you spawn workers, you coordinate their work asynchronously. **Spawning is non-blocking** - workers run in the background while you can continue the conversation.
+
+### Spawning Workers
+
+\`\`\`
+User: "Spawn 3 engineers to work on the API"
+You: [call bb_spawn_worker or bb_spawn_team]
+"Spawned Engineer-01, Engineer-02, Engineer-03. They're working in parallel."
+\`\`\`
+
+### Checking Progress
+
+Users can ask about progress at any time:
+
+\`\`\`
+User: "What's the status?"
+You: [call bb_worker_status]
+"Engineer-01 is working on auth.ts, Engineer-02 completed their task, Engineer-03 is still working."
+
+User: "Show me Engineer-02's results"
+You: [call bb_worker_results, then read the actual files]
+"Engineer-02 found that the auth module needs refactoring. Looking at auth.ts now..."
+\`\`\`
+
+### Getting Results
+
+**CRITICAL: Verify work by reading actual files, not just result summaries.**
+
+1. Call \`bb_worker_results\` to get bead summaries
+2. Read the actual files that workers touched
+3. Synthesize an informed response
+
+\`\`\`
+User: "Any updates?"
+You: 
+1. [call bb_worker_status] - see who completed
+2. [call bb_worker_results] - get bead summaries
+3. [read auth.ts, user-service.ts] - verify actual changes
+4. Respond with synthesis:
+
+"Engineer-01 and Engineer-03 have completed:
+
+- **Engineer-01**: Refactored auth.ts to use JWT tokens (lines 42-78 modified)
+- **Engineer-03**: Added refresh token logic to user-service.ts
+
+The changes look solid. Ready to proceed with testing?"
+\`\`\`
+
+### Why Read Files?
+
+The bead summary is high-level. Reading files lets you:
+- Verify the implementation matches intent
+- Understand technical details for follow-up work
+- Provide informed synthesis to the user
+- Catch issues the worker might have missed
+
+---
+
+# Current Workspace State
+
+You are currently orchestrating the project at:
+${workspaceRoot}
+
+## Available Agent Types
+\`\`\`json
+${agentTypesContext}
+\`\`\`
+
+## Available Mission Templates
+\`\`\`json
+${templatesContext}
+\`\`\`
+
+## Active Project Tasks (via Dolt)
+\`\`\`json
+${issuesContext}
+\`\`\`
+
+You should follow templates by default but can recommend sensible deviations if the active task graph requires it (e.g., if a needed agent type is missing or if concurrency needs demand more workers).
+Always use your provided tools to read the latest state, manage the mailbox, and update your presence.
+`;
+}
diff --git a/src/tui/tools/bb-assign-agent.ts b/src/tui/tools/bb-assign-agent.ts
new file mode 100644
index 0000000..929b26d
--- /dev/null
+++ b/src/tui/tools/bb-assign-agent.ts
@@ -0,0 +1,45 @@
+import { Type } from '@sinclair/typebox';
+import type { ToolDefinition } from '@mariozechner/pi-coding-agent';
+
+export function createAssignAgentTool(projectRoot: string): ToolDefinition {
+  return {
+    name: 'bb_assign_agent',
+    label: 'Assign Agent to Bead',
+    description: 'Assign an agent type to a bead. This signals which kind of agent should work on this task. Does NOT spawn the agent - use bb_spawn_worker for that.',
+    parameters: Type.Object({
+      bead_id: Type.String({ description: 'Bead ID to assign agent type to' }),
+      agent_type: Type.String({ description: 'Agent type ID (e.g., "engineer", "architect", "reviewer", "tester", "investigator", "shipper")' }),
+    }),
+    async execute(_toolCallId: string, params: unknown): Promise<any> {
+      const { bead_id, agent_type } = params as { bead_id: string; agent_type: string };
+
+      // Validate agent type
+      const validAgentTypes = ['architect', 'engineer', 'reviewer', 'tester', 'investigator', 'shipper'];
+      if (!validAgentTypes.includes(agent_type)) {
+        return {
+          content: [{ 
+            type: 'text', 
+            text: `Error: Invalid agent type "${agent_type}". Valid options: ${validAgentTypes.join(', ')}` 
+          }],
+          isError: true,
+        };
+      }
+
+      // Note: In a full implementation, this would update the bead in the database
+      // For now, we just return success and the orchestrator should remember this assignment
+      
+      return {
+        content: [{
+          type: 'text',
+          text: `Assigned agent type "${agent_type}" to bead ${bead_id}.
+
+When ready to work on this bead, spawn an agent with:
+\`\`\`
+bb_spawn_worker(task_id: "${bead_id}", agent_type: "${agent_type}", task_context: "...")
+\`\`\``,
+        }],
+        details: { bead_id, agent_type },
+      };
+    },
+  };
+}
